stages:
  - prep
  - test
  - plan
  - apply


variables:
  CI_REGISTRY_IMAGE_REF: ${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_SLUG}
  CI_REGISTRY_IMAGE_FULL: ${CI_REGISTRY_IMAGE}:${CI_COMMIT_SHORT_SHA}

tflint:
  stage: prep
  image:
    name: hashicorp/terraform:0.12.28
    entrypoint: [/bin/sh, -c]
  script: terraform fmt -recursive -check tf

package:
  stage: prep
  image: alpine
  script:
    - apk add -U zip
    - zip -0 -r package.zip src/ package.json package-lock.json .npmrc
  only:
    - master
  artifacts:
    paths:
      - package.zip

build:
  stage: prep
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [/busybox/sh, -c]
  script:
    - mkdir -p /root/.docker
    - echo "{\"auths\":{\"$CI_REGISTRY\":{\"auth\":\"$(echo -n $CI_REGISTRY_USER:$CI_REGISTRY_PASSWORD | base64)\"}}}" > $DOCKER_CONFIG/config.json
    - /kaniko/executor --cache --context dir://. --destination $CI_REGISTRY_IMAGE_FULL --destination $CI_REGISTRY_IMAGE_REF --destination $CI_REGISTRY_IMAGE:latest

test:
  stage: test
  image: ${CI_REGISTRY_IMAGE_FULL}
  script:
    - cd /opt/app
    - make ci
  needs:
    - build

plan_dev: &plan
  stage: plan
  environment: dev
  image:
    name: hashicorp/terraform:0.13.2
    entrypoint: [/bin/sh, -c]
  script:
    - apk add -U make openssl
    - cd tf
    - mkdir .terraform && echo $CI_ENVIRONMENT_NAME > .terraform/environment
    - export TF_VAR_env=$CI_ENVIRONMENT_NAME
    - export TF_VAR_commit_short_sha=$CI_COMMIT_SHORT_SHA
    - make init_ci
    - make plan_ci
    - openssl enc $ENC_ARGS -pass file:$tfplan_pass -in out.tfplan -out out.tfplan.enc
  only:
    - master
  artifacts:
    expire_in: 6 hours
    paths:
      - tf/.terraform
      - tf/out.tfplan.enc
plan_prod:
  <<: *plan
  environment: prod

apply_dev: &apply
  stage: apply
  when: manual
  environment: dev
  image:
    name: hashicorp/terraform:0.13.2
    entrypoint: [/bin/sh, -c]
  script:
    - apk add -U make openssl
    - cd tf
    - openssl enc $ENC_ARGS -d -pass file:$tfplan_pass -out out.tfplan -in out.tfplan.enc
    - make init_ci
    - make apply_ci
  only:
    - master
  needs:
    - job: package
      artifacts: true
    - job: plan_dev
      artifacts: true
apply_prod:
  <<: *apply
  environment: prod
  needs:
    - job: package
      artifacts: true
    - job: plan_prod
      artifacts: true
